#include "Widget.h"

#include <QDialog>
#include <QMenu>
#include <QPushButton>
#include <QMouseEvent>

class MyDialog : public QDialog
{
public:
    explicit MyDialog(QWidget* p_Parent = nullptr) : QDialog(p_Parent)
    {
        setMinimumSize(300, 300);
    }

    virtual ~MyDialog()
    {
    }

protected:
    virtual void mousePressEvent(QMouseEvent* p_Event) override
    {
        QDialog::mousePressEvent(p_Event);

        if (p_Event->button() == Qt::RightButton)
        {
            QMenu menu;
            menu.addAction("Action 1");
            menu.addAction("Action 2");
            menu.addAction("Action 3");

            menu.exec(QCursor::pos());
        }
    }
};

Widget::Widget(QWidget *parent)
    : QWidget(parent)
{
    setMinimumSize(500, 500);
    QPushButton* btn = new QPushButton("Press", this);
    btn->setGeometry(0, 0, 60, 30);

    MyDialog* dlg = new MyDialog(this);
    dlg->hide();

    connect(btn, &QPushButton::clicked, dlg, &MyDialog::exec);
}

Widget::~Widget()
{

}
